## xen 4.6.6

=== debian/changelog ===
xen (2001:4.6.6-45+deb8u1) jessie; urgency=medium

  * Build for jessie

 -- Marek Marczykowski-Górecki <user@build-debian3>  Tue, 20 Nov 2018 16:41:16 +0000

xen (2001:4.6.6-45) unstable; urgency=medium

  * debian: reuse upstream orig tarball
  * Apply XSA-275, XSA-280

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 20 Nov 2018 12:49:40 +0100

xen (2001:4.6.6-44) unstable; urgency=medium

  [ Frédéric Pierret ]
  * Allow setting DISTFILES_MIRROR in the builder.conf

  [ Marek Marczykowski-Górecki ]
  * Update to stable-4.6 to get fixes for XSA-273
  * Disable SMT by default

  [ unman ]
  * Removed wheezy and trusty builds, consolidated Build-Depends
  * Fix typo in Debian Build-Depends

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 01 Sep 2018 16:03:23 +0200

xen (2001:4.6.6-43) unstable; urgency=medium

  * Fix build on Debian buster
  * Apply stable patches on top of Xen 4.6.6

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 17 Jul 2018 00:32:36 +0200

xen (2001:4.6.6-42) unstable; urgency=medium

  * rpm: Fix condition syntax
  * Apply XSA-267 patches
  * Update context of XSA-267 patches

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 14 Jun 2018 00:21:18 +0200

xen (2001:4.6.6-41) unstable; urgency=medium

  * Apply XSA 263 patches
  * Update prerequisites and fix context in XSA 263

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 22 May 2018 22:03:28 +0200

xen (2001:4.6.6-40) unstable; urgency=medium

  * Apply XSA 260-262

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 08 May 2018 17:30:36 +0200

xen (2001:4.6.6-39) unstable; urgency=medium

  [ Simon Gaiser ]
  * Use upstream suspend fix

  [ Marek Marczykowski-Górecki ]
  * Update core-vchan-xen submodule
  * Fix gcc 7 compile warning
  * Apply gcc-8 fixes

  [ Frédéric Pierret ]
  * Fix '%files hypervisor' list: files in /usr/lib/debug are not just
    in efi builds

  [ Marek Marczykowski-Górecki ]
  * More GCC 8 fixes
  * travis: add fc27, fc28, centos7
  * rpm: avoid build failure from missing build-id in xen-syms

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 07 May 2018 01:10:16 +0200

xen (2001:4.6.6-38) unstable; urgency=medium

  [ Simon Gaiser ]
  * Add upstream patches for improved early microcode loading
  * Backport microcode loading patch to 4.6.6
  * Add fix for SPEC_CTRL/PRED_CMD in dom0
  * Fix save/restore when having IBRS/IBPB support
  * Add some other patches from staging-4.6
  * Fix resume when using microcode update

  [ Marek Marczykowski-Górecki ]
  * travis: drop separate check for fc23 vm

  [ Frédéric Pierret ]
  * Fix GMP cross compilation

  [ Marek Marczykowski-Górecki ]
  * rpm: require patched gcc only for dom0 build

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 15 Apr 2018 04:37:50 +0200

xen (2001:4.6.6-37) unstable; urgency=medium

  [ unman ]
  * Remove zesty and configure for build of artful templates

  [ Marek Marczykowski-Górecki ]
  * travis: add buster

  [ Simon Gaiser ]
  * Add BTI mitigation patches from XSA 254
  * Require gcc with BTI mitigation support

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 14 Mar 2018 14:32:04 +0100

xen (2001:4.6.6-36) unstable; urgency=medium

  [ Simon Gaiser ]
  * Add "stage 1" PTI patches against Meltdown

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 23 Jan 2018 16:10:14 +0100

xen (2001:4.6.6-35) wheezy; urgency=medium

  * Apply XSA-246 and XSA-247

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 28 Nov 2017 13:17:20 +0100

xen (2001:4.6.6-34) wheezy; urgency=medium

  * Apply XSA 236 patch

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 24 Oct 2017 16:37:09 +0200

xen (2001:4.6.6-33) unstable; urgency=medium

  * Workaround for qemu-xen build failure on Fedora 26

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 13 Oct 2017 22:56:39 +0200

xen (2001:4.6.6-32) unstable; urgency=medium

  * Apply XSA 237-244 patches

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 12 Oct 2017 13:33:55 +0200

xen (2001:4.6.6-31) unstable; urgency=medium

  [ Frederic Pierret (Epitre) ]
  * Fix GCC7 warnings/errors

  [ Marek Marczykowski-Górecki ]
  * travis: switch to Qubes 3.2, add fc25 and fc26 build targets
  * debian: add build deps tag for buster

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 24 Sep 2017 03:24:42 +0200

xen (2001:4.6.6-30) unstable; urgency=medium

  * Apply XSA 231-234 patches

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 02 Sep 2017 00:51:24 +0200

xen (2001:4.6.6-29) unstable; urgency=medium

  * version 4.6.6-28
  * Apply XSA 226-230 patches

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 10 Aug 2017 14:29:27 +0200

xen (2001:4.6.6-28) unstable; urgency=medium

  [ unman ]
  * Enable build for Zesty

  [ Marek Marczykowski-Górecki ]
  * Update download url for Xen
  * version 4.6.6-28

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 29 Jul 2017 14:15:47 +0200

xen (2001:4.6.5-28) unstable; urgency=medium

  [ Olivier MEDOC ]
  * libxl: Fix compilation Warnings causing build failure when building
    with glibc-2.25

  [ Marek Marczykowski-Górecki ]
  * Apply XSA216-224

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 20 Jun 2017 03:15:53 +0200

xen (2001:4.6.5-27) unstable; urgency=medium

  * Update debian/changelog
  * Apply XSA 213, 214, 215

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 21 Apr 2017 17:20:03 +0200

xen (2001:4.6.5-26) unstable; urgency=medium

  * version 4.6.5-26

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 21 Apr 2017 17:17:22 +0200

xen (2001:4.6.4-26) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]

