=== debian/control ===
Source: xen
Section: kernel
Priority: optional
Maintainer: Jason Mehring <nrgaway@gmail.com>
Build-Depends: 
    autotools-dev,
    bcc,
    cmake,
    comerr-dev,
    debhelper (>= 9), 
    dh-autoreconf,
    dh-python,
    e2fslibs-dev,
    file,
    iasl,
    libaio-dev, 
    libaio1:amd64,
    libc6-i386,
    libfdt-dev,
    libglib2.0-dev,
    liblzma-dev:amd64,
    libmagic1:amd64,
    libsystemd-dev,
    libsystemd-dev:amd64,
    libncurses5-dev:amd64,
    libpixman-1-dev,
    libpython2.7:amd64,
    libpython2.7-dev,
    libssl-dev, 
    libssl-dev:amd64,
    libyajl-dev,
    libyajl-dev:amd64,
    mawk,
    mime-support,
    perl,
    pkg-config,
    python2.7-minimal,
    seabios,
    uuid-dev:amd64,
    zlib1g-dev,
X-Python-Version: 2.7
Standards-Version: 3.9.5
Homepage: http://www.qubes-os.org
Vcs-Git: git://git.qubes-os.org/marmarek/vmm-xen-debian.git

Package: libxen-4.6
Section: libs
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Conflicts: libxen-4.4
Description: Libraries for Xen tools
 This package contains the libraries needed to run Xen tools inside of Qubes VM

Package: libxenstore3.0
Section: libs
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Xenstore communications library for Xen
 This package contains the client library interface to XenStore.

Package: libxen-dev
Section: libdevel
Architecture: amd64
Depends: libxen-4.6 (= ${binary:Version}), libxenstore3.0 (= ${binary:Version}), ${misc:Depends}
Description: Development libraries for Xen tools
 This package contains what's needed to develop applications
 which manage Xen virtual machines.

Package: xenstore-utils
Architecture: amd64
Section: admin
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: xen-utils-common (<= 3.1.0-1)
Conflicts: xen-utils-common (<= 3.1.0-1)
Description: Xenstore command line utilities for Xen
 This package contains command line utilities for interacting with
 XenStore.
 .
 XenStore is a shared database used for interdomain communication of
 configuration and status information.  It is accessible to all domains
 running on the same Xen host.  See http://wiki.xen.org/wiki/XenStore for
 more information.
 .
 In the common case these tools are used by the Xen toolstack running in
 domain0 (or a driver domain) however they may also be used in a guest
 domain to support local scripting which wants to communicate via XenStore.

Package: xen-utils-common
Architecture: all
Depends: lsb-base, python, udev, xenstore-utils, ${shlibs:Depends}, ${python:Depends}, ${misc:Depends}
X-Python-Version: ${python:Versions}
Description: Xen administrative tools - common files
 The userspace tools to manage a system virtualized through the Xen virtual
 machine monitor.
 .
 This package is only required on the host system (Domain 0) and not on the
 virtual guest systems (Domain U).
